"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = __importStar(require("react"));
var BasicDialog_1 = require("../Dialog/BasicDialog");
var ErrorMessageBox_1 = __importDefault(require("./ErrorMessageBox"));
/**
 * Component that manages the display of error messages. Can be configured to display a dialog, a message box, or neither.
 *
 * @param {ErrorManagerProps} props - props of errorManager component
 *
 * @category Component
 */
var ErrorManager = function (props) {
    var children = props.children, _a = props.mode, mode = _a === void 0 ? 'dialog' : _a, title = props.title, _b = props.error, error = _b === void 0 ? '' : _b, errorOptions = props.errorOptions, titleOptions = props.titleOptions, _c = props.onClose, onClose = _c === void 0 ? function () { } : _c, dialogConfig = props.dialogConfig, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    _d = props.t, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    t = _d === void 0 ? function (key, _options) { return key; } : _d, _e = props.messageBoxConfig, messageBoxConfig = _e === void 0 ? {
        position: 'top',
    } : _e;
    var ErrorDialogWithProps = (0, react_1.useCallback)(function () {
        var _a, _b, _c;
        return (react_1.default.createElement(BasicDialog_1.BasicDialog, { open: error.length > 0, title: t((_b = (_a = dialogConfig === null || dialogConfig === void 0 ? void 0 : dialogConfig.title) !== null && _a !== void 0 ? _a : title) !== null && _b !== void 0 ? _b : 'Error', titleOptions), body: t(error, errorOptions), onClose: onClose, dismissButtonText: t((_c = dialogConfig === null || dialogConfig === void 0 ? void 0 : dialogConfig.dismissLabel) !== null && _c !== void 0 ? _c : 'Okay'), sx: dialogConfig === null || dialogConfig === void 0 ? void 0 : dialogConfig.sx }));
    }, [dialogConfig, title, error, errorOptions, titleOptions, onClose, t]);
    var ErrorMessageBoxWithProps = (0, react_1.useCallback)(function () {
        var _a, _b;
        var _c = messageBoxConfig.dismissible, dismissible = _c === void 0 ? true : _c, fontColor = messageBoxConfig.fontColor, backgroundColor = messageBoxConfig.backgroundColor, sx = messageBoxConfig.sx;
        return (react_1.default.createElement(ErrorMessageBox_1.default, { title: t((_b = (_a = messageBoxConfig === null || messageBoxConfig === void 0 ? void 0 : messageBoxConfig.title) !== null && _a !== void 0 ? _a : title) !== null && _b !== void 0 ? _b : 'Error', titleOptions), errorMessage: t(error, errorOptions), dismissible: dismissible, sx: sx, backgroundColor: backgroundColor, fontColor: fontColor, onClose: onClose }));
    }, [error, errorOptions, titleOptions, title, messageBoxConfig, onClose, t]);
    return mode === 'dialog' && error.length > 0 ? (react_1.default.createElement(react_1.default.Fragment, null,
        children,
        react_1.default.createElement(ErrorDialogWithProps, null))) : mode === 'message-box' && error.length > 0 ? (react_1.default.createElement(react_1.default.Fragment, null,
        messageBoxConfig.position !== 'bottom' && react_1.default.createElement(ErrorMessageBoxWithProps, null),
        children,
        messageBoxConfig.position === 'bottom' && react_1.default.createElement(ErrorMessageBoxWithProps, null))) : (react_1.default.createElement(react_1.default.Fragment, null, children));
};
exports.default = ErrorManager;
