"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.i18nAuthInstance = void 0;
var i18next_1 = __importDefault(require("i18next"));
var AuthDictionaries_1 = require("./AuthDictionaries");
var SharedDictionaries_1 = require("../SharedDictionaries");
exports.i18nAuthInstance = i18next_1.default.createInstance({
    fallbackLng: 'en',
    ns: ['bluiAuth', 'bluiCommon'],
    defaultNS: 'bluiAuth',
    load: 'languageOnly',
    detection: {
        order: ['querystring', 'localStorage', 'navigator'],
        caches: ['localStorage'],
    },
    react: { useSuspense: false },
    interpolation: { escapeValue: false },
    resources: {
        en: {
            bluiAuth: __assign({}, AuthDictionaries_1.AuthDictionaries.english.translation),
            bluiCommon: __assign({}, SharedDictionaries_1.SharedDictionaries.english.translation),
        },
        fr: {
            bluiAuth: __assign({}, AuthDictionaries_1.AuthDictionaries.french.translation),
            bluiCommon: __assign({}, SharedDictionaries_1.SharedDictionaries.french.translation),
        },
        es: {
            bluiAuth: __assign({}, AuthDictionaries_1.AuthDictionaries.spanish.translation),
            bluiCommon: __assign({}, SharedDictionaries_1.SharedDictionaries.spanish.translation),
        },
        zh: {
            bluiAuth: __assign({}, AuthDictionaries_1.AuthDictionaries.chinese.translation),
            bluiCommon: __assign({}, SharedDictionaries_1.SharedDictionaries.chinese.translation),
        },
        pt: {
            bluiAuth: __assign({}, AuthDictionaries_1.AuthDictionaries.portuguese.translation),
            bluiCommon: __assign({}, SharedDictionaries_1.SharedDictionaries.portuguese.translation),
        },
    },
}, 
// We must provide a function as second parameter, otherwise i18next errors
// eslint-disable-next-line @typescript-eslint/no-unused-vars
function (err, _t) {
    // eslint-disable-next-line no-console
    if (err)
        return console.log(err);
});
exports.default = { i18nAuthInstance: exports.i18nAuthInstance };
