"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErrorContextProvider = exports.ErrorContext = exports.useErrorContext = void 0;
var react_1 = require("react");
var context_1 = require("./context");
Object.defineProperty(exports, "ErrorContext", { enumerable: true, get: function () { return context_1.ErrorContext; } });
var provider_1 = require("./provider");
Object.defineProperty(exports, "ErrorContextProvider", { enumerable: true, get: function () { return provider_1.ErrorContextProvider; } });
/**
 * Hook to get top level error data
 *
 * @category Hooks
 * @private
 * @internal
 */
var useErrorContext = function () {
    var context = (0, react_1.useContext)(context_1.ErrorContext);
    if (context === null) {
        throw new Error('useErrorContext must be used within ErrorContextProvider');
    }
    return context;
};
exports.useErrorContext = useErrorContext;
