"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreateAccountScreenBase = void 0;
var react_1 = __importStar(require("react"));
var WorkflowCard_1 = require("../../components/WorkflowCard");
var WorkflowCardActions_1 = require("../../components/WorkflowCard/WorkflowCardActions");
var WorkflowCardBody_1 = require("../../components/WorkflowCard/WorkflowCardBody");
var WorkflowCardHeader_1 = require("../../components/WorkflowCard/WorkflowCardHeader");
var WorkflowCardInstructions_1 = require("../../components/WorkflowCard/WorkflowCardInstructions");
var TextField_1 = __importDefault(require("@mui/material/TextField"));
var ErrorManager_1 = __importDefault(require("../../components/Error/ErrorManager"));
/**
 * Component that renders a screen for the user to enter their email address to start the
 * account creation process.
 *
 * @param {CreateAccountScreenProps} props - props of CreateAccountScreen base component
 *
 * @category Component
 */
var CreateAccountScreenBase = function (props) {
    var _a;
    var 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    _b = props.emailValidator, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    emailValidator = _b === void 0 ? function (email) { return true; } : _b, emailLabel = props.emailLabel, initialValue = props.initialValue, emailTextFieldProps = props.emailTextFieldProps, inputRef = props.inputRef, errorDisplayConfig = props.errorDisplayConfig, _c = props.WorkflowCardBaseProps, cardBaseProps = _c === void 0 ? {} : _c, _d = props.WorkflowCardInstructionProps, instructionsProps = _d === void 0 ? {} : _d, _e = props.WorkflowCardActionsProps, actionsProps = _e === void 0 ? {} : _e, _f = props.WorkflowCardHeaderProps, headerProps = _f === void 0 ? {} : _f, otherProps = __rest(props, ["emailValidator", "emailLabel", "initialValue", "emailTextFieldProps", "inputRef", "errorDisplayConfig", "WorkflowCardBaseProps", "WorkflowCardInstructionProps", "WorkflowCardActionsProps", "WorkflowCardHeaderProps"]);
    var _g = react_1.default.useState(initialValue ? initialValue : ''), emailInput = _g[0], setEmailInput = _g[1];
    var _h = react_1.default.useState((_a = emailValidator(initialValue !== null && initialValue !== void 0 ? initialValue : '')) !== null && _a !== void 0 ? _a : false), isEmailValid = _h[0], setIsEmailValid = _h[1];
    var _j = react_1.default.useState(''), emailError = _j[0], setEmailError = _j[1];
    var _k = react_1.default.useState(false), shouldValidateEmail = _k[0], setShouldValidateEmail = _k[1];
    var handleEmailInputChange = (0, react_1.useCallback)(function (email) {
        setEmailInput(email);
        var emailValidatorResponse = emailValidator(email);
        setIsEmailValid(typeof emailValidatorResponse === 'boolean' ? emailValidatorResponse : false);
        setEmailError(typeof emailValidatorResponse === 'string' ? emailValidatorResponse : '');
    }, [emailValidator]);
    (0, react_1.useEffect)(function () {
        if (emailInput.length > 0) {
            setShouldValidateEmail(true);
            handleEmailInputChange(emailInput);
        }
        // eslint-disable-next-line react-hooks/exhaustive-deps
    }, []);
    return (react_1.default.createElement(WorkflowCard_1.WorkflowCard, __assign({}, cardBaseProps, otherProps),
        react_1.default.createElement(WorkflowCardHeader_1.WorkflowCardHeader, __assign({}, headerProps)),
        react_1.default.createElement(WorkflowCardInstructions_1.WorkflowCardInstructions, __assign({}, instructionsProps)),
        react_1.default.createElement(WorkflowCardBody_1.WorkflowCardBody, null,
            react_1.default.createElement(ErrorManager_1.default, __assign({}, errorDisplayConfig),
                react_1.default.createElement(TextField_1.default, __assign({ ref: inputRef, type: 'email', label: emailLabel, fullWidth: true, value: emailInput, variant: "filled", error: shouldValidateEmail && !isEmailValid, helperText: shouldValidateEmail && emailError }, emailTextFieldProps, { onChange: function (e) {
                        // eslint-disable-next-line no-unused-expressions
                        (emailTextFieldProps === null || emailTextFieldProps === void 0 ? void 0 : emailTextFieldProps.onChange) && emailTextFieldProps.onChange(e);
                        handleEmailInputChange(e.target.value);
                    }, onKeyUp: function (e) {
                        var _a;
                        if (e.key === 'Enter' &&
                            ((emailInput.length > 0 && isEmailValid) || actionsProps.canGoNext))
                            (_a = actionsProps === null || actionsProps === void 0 ? void 0 : actionsProps.onNext) === null || _a === void 0 ? void 0 : _a.call(actionsProps);
                    }, onBlur: function (e) {
                        // eslint-disable-next-line no-unused-expressions
                        (emailTextFieldProps === null || emailTextFieldProps === void 0 ? void 0 : emailTextFieldProps.onBlur) && emailTextFieldProps.onBlur(e);
                        setShouldValidateEmail(true);
                    } })))),
        react_1.default.createElement(WorkflowCardActions_1.WorkflowCardActions, __assign({}, actionsProps, { canGoNext: (emailInput.length > 0 && isEmailValid && actionsProps.canGoNext) }))));
};
exports.CreateAccountScreenBase = CreateAccountScreenBase;
