"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreatePasswordScreenBase = void 0;
var react_1 = __importDefault(require("react"));
var components_1 = require("../../components");
var SetPassword_1 = require("../../components/SetPassword");
var ErrorManager_1 = __importDefault(require("../../components/Error/ErrorManager"));
/**
 * The component renders a screen with the password and confirm password field for creating a new password.
 *
 * @param {CreatePasswordScreenProps} props - props of CreatePasswordScreen base component
 *
 * @category Component
 */
var CreatePasswordScreenBase = function (props) {
    var errorDisplayConfig = props.errorDisplayConfig, _a = props.WorkflowCardBaseProps, cardBaseProps = _a === void 0 ? {} : _a, _b = props.WorkflowCardInstructionProps, instructionsProps = _b === void 0 ? {} : _b, _c = props.WorkflowCardActionsProps, actionsProps = _c === void 0 ? {} : _c, _d = props.WorkflowCardHeaderProps, headerProps = _d === void 0 ? {} : _d, _e = props.PasswordProps, passwordProps = _e === void 0 ? { onPasswordChange: function () { return ({}); } } : _e, otherProps = __rest(props, ["errorDisplayConfig", "WorkflowCardBaseProps", "WorkflowCardInstructionProps", "WorkflowCardActionsProps", "WorkflowCardHeaderProps", "PasswordProps"]);
    return (react_1.default.createElement(components_1.WorkflowCard, __assign({}, cardBaseProps, otherProps),
        react_1.default.createElement(components_1.WorkflowCardHeader, __assign({}, headerProps)),
        react_1.default.createElement(components_1.WorkflowCardInstructions, __assign({}, instructionsProps)),
        react_1.default.createElement(components_1.WorkflowCardBody, null,
            react_1.default.createElement(ErrorManager_1.default, __assign({}, errorDisplayConfig),
                react_1.default.createElement(SetPassword_1.SetPassword, __assign({}, passwordProps)))),
        react_1.default.createElement(components_1.WorkflowCardActions, __assign({}, actionsProps))));
};
exports.CreatePasswordScreenBase = CreatePasswordScreenBase;
