"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EulaScreen = void 0;
var react_1 = __importStar(require("react"));
var EulaScreenBase_1 = require("./EulaScreenBase");
var contexts_1 = require("../../contexts");
var useErrorManager_1 = require("../../contexts/ErrorContext/useErrorManager");
var react_i18next_1 = require("react-i18next");
/**
 * Component that renders a screen displaying the EULA and requests acceptance via a checkbox.
 *
 * @param {EulaScreenProps} props - props of EULA screen
 *
 * @category Component
 */
var EulaScreen = function (props) {
    var t = (0, react_i18next_1.useTranslation)().t;
    var _a = (0, contexts_1.useRegistrationContext)(), actions = _a.actions, language = _a.language;
    var _b = (0, useErrorManager_1.useErrorManager)(), triggerError = _b.triggerError, errorManagerConfig = _b.errorManagerConfig;
    var errorDisplayConfig = __assign(__assign(__assign({}, errorManagerConfig), props.errorDisplayConfig), { onClose: function () {
            if (props.errorDisplayConfig && props.errorDisplayConfig.onClose)
                props.errorDisplayConfig.onClose();
            if (errorManagerConfig.onClose)
                errorManagerConfig === null || errorManagerConfig === void 0 ? void 0 : errorManagerConfig.onClose();
        } });
    var regWorkflow = (0, contexts_1.useRegistrationWorkflowContext)();
    var nextScreen = regWorkflow.nextScreen, previousScreen = regWorkflow.previousScreen, screenData = regWorkflow.screenData, currentScreen = regWorkflow.currentScreen, totalScreens = regWorkflow.totalScreens, isInviteRegistration = regWorkflow.isInviteRegistration, updateScreenData = regWorkflow.updateScreenData;
    var WorkflowCardBaseProps = props.WorkflowCardBaseProps, WorkflowCardHeaderProps = props.WorkflowCardHeaderProps, WorkflowCardActionsProps = props.WorkflowCardActionsProps, eulaContent = props.eulaContent, _c = props.checkboxLabel, checkboxLabel = _c === void 0 ? t('bluiRegistration:REGISTRATION.EULA.AGREE_TERMS') : _c, html = props.html, initialCheckboxValue = props.initialCheckboxValue, otherEulaScreenProps = __rest(props, ["WorkflowCardBaseProps", "WorkflowCardHeaderProps", "WorkflowCardActionsProps", "eulaContent", "checkboxLabel", "html", "initialCheckboxValue"]);
    var eulaAccepted = initialCheckboxValue ? initialCheckboxValue : screenData.Eula.accepted;
    var _d = (0, react_1.useState)(true), isLoading = _d[0], setIsLoading = _d[1];
    var _e = (0, react_1.useState)(), eulaData = _e[0], setEulaData = _e[1];
    var _f = (0, react_1.useState)(false), eulaFetchError = _f[0], setEulaFetchError = _f[1];
    var loadAndCacheEula = (0, react_1.useCallback)(function () { return __awaiter(void 0, void 0, void 0, function () {
        var eulaText, _error_1;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    setIsLoading(true);
                    if (!!eulaContent) return [3 /*break*/, 6];
                    setEulaData(t('bluiRegistration:REGISTRATION.EULA.LOADING'));
                    _b.label = 1;
                case 1:
                    _b.trys.push([1, 3, 4, 5]);
                    return [4 /*yield*/, ((_a = actions === null || actions === void 0 ? void 0 : actions.loadEula) === null || _a === void 0 ? void 0 : _a.call(actions, language))];
                case 2:
                    eulaText = _b.sent();
                    setEulaData(eulaText);
                    setIsLoading(false);
                    return [3 /*break*/, 5];
                case 3:
                    _error_1 = _b.sent();
                    triggerError(_error_1);
                    setEulaFetchError(true);
                    setIsLoading(false);
                    return [3 /*break*/, 5];
                case 4:
                    setIsLoading(false);
                    return [7 /*endfinally*/];
                case 5: return [3 /*break*/, 7];
                case 6:
                    setIsLoading(false);
                    setEulaData(eulaContent);
                    _b.label = 7;
                case 7: return [2 /*return*/];
            }
        });
    }); }, [eulaContent, t, actions, language]);
    var onNext = (0, react_1.useCallback)(function () { return __awaiter(void 0, void 0, void 0, function () {
        var isAccExist, _a, codeValid, accountExists, _error_2;
        var _b, _c;
        return __generator(this, function (_d) {
            switch (_d.label) {
                case 0:
                    setIsLoading(true);
                    _d.label = 1;
                case 1:
                    _d.trys.push([1, 7, 8, 9]);
                    if (!screenData.Eula.accepted) return [3 /*break*/, 3];
                    return [4 /*yield*/, ((_b = actions === null || actions === void 0 ? void 0 : actions.acceptEula) === null || _b === void 0 ? void 0 : _b.call(actions))];
                case 2:
                    _d.sent();
                    _d.label = 3;
                case 3:
                    isAccExist = void 0;
                    if (!isInviteRegistration) return [3 /*break*/, 5];
                    return [4 /*yield*/, ((_c = actions === null || actions === void 0 ? void 0 : actions.validateUserRegistrationRequest) === null || _c === void 0 ? void 0 : _c.call(actions, screenData.VerifyCode.code, screenData.CreateAccount.emailAddress))];
                case 4:
                    _a = (_d.sent()) || {}, codeValid = _a.codeValid, accountExists = _a.accountExists;
                    isAccExist = accountExists;
                    if (isAccExist) {
                        updateScreenData({
                            screenId: 'Eula',
                            values: { accepted: screenData.Eula.accepted },
                            isAccountExist: accountExists,
                        });
                    }
                    else {
                        if (typeof codeValid === 'boolean') {
                            if (codeValid)
                                void nextScreen({
                                    screenId: 'Eula',
                                    values: { accepted: screenData.Eula.accepted },
                                    isAccountExist: accountExists,
                                });
                            else {
                                triggerError(new Error(t('bluiRegistration:SELF_REGISTRATION.VERIFY_EMAIL.CODE_VALIDATOR_ERROR')));
                            }
                        }
                        else {
                            triggerError(new Error(codeValid));
                        }
                    }
                    return [3 /*break*/, 6];
                case 5:
                    void nextScreen({
                        screenId: 'Eula',
                        values: { accepted: screenData.Eula.accepted },
                        isAccountExist: isAccExist,
                    });
                    _d.label = 6;
                case 6: return [3 /*break*/, 9];
                case 7:
                    _error_2 = _d.sent();
                    triggerError(_error_2);
                    return [3 /*break*/, 9];
                case 8:
                    setIsLoading(false);
                    return [7 /*endfinally*/];
                case 9: return [2 /*return*/];
            }
        });
    }); }, [actions, nextScreen, triggerError, isInviteRegistration, screenData, t, updateScreenData]);
    var onPrevious = (0, react_1.useCallback)(function () {
        setIsLoading(true);
        try {
            previousScreen({
                screenId: 'Eula',
                values: { accepted: eulaAccepted },
            });
        }
        catch (_error) {
            triggerError(_error);
        }
        finally {
            setIsLoading(false);
        }
    }, [previousScreen, triggerError, eulaAccepted]);
    var updateEulaAcceptedStatus = (0, react_1.useCallback)(function (accepted) {
        var _a;
        screenData.Eula = __assign(__assign({}, screenData), { accepted: accepted });
        (_a = props === null || props === void 0 ? void 0 : props.onEulaAcceptedChange) === null || _a === void 0 ? void 0 : _a.call(props, accepted);
    }, 
    // eslint-disable-next-line react-hooks/exhaustive-deps
    [screenData]);
    (0, react_1.useEffect)(function () {
        void loadAndCacheEula();
    }, [loadAndCacheEula]);
    var _g = props.checkboxProps, checkboxProps = _g === void 0 ? __assign(__assign({}, props.checkboxProps), { disabled: eulaFetchError }) : _g;
    var workflowCardHeaderProps = __assign({ title: t('bluiRegistration:REGISTRATION.STEPS.LICENSE') }, WorkflowCardHeaderProps);
    var workflowCardActionsProps = __assign(__assign({ showNext: true, nextLabel: t('bluiCommon:ACTIONS.NEXT'), canGoNext: true, showPrevious: true, previousLabel: t('bluiCommon:ACTIONS.BACK'), canGoPrevious: true, currentStep: currentScreen, totalSteps: totalScreens }, WorkflowCardActionsProps), { onNext: function () {
            var _a;
            void onNext();
            (_a = WorkflowCardActionsProps === null || WorkflowCardActionsProps === void 0 ? void 0 : WorkflowCardActionsProps.onNext) === null || _a === void 0 ? void 0 : _a.call(WorkflowCardActionsProps);
        }, onPrevious: function () {
            var _a;
            void onPrevious();
            (_a = WorkflowCardActionsProps === null || WorkflowCardActionsProps === void 0 ? void 0 : WorkflowCardActionsProps.onPrevious) === null || _a === void 0 ? void 0 : _a.call(WorkflowCardActionsProps);
        } });
    var _h = props.refreshConfig, refreshConfig = _h === void 0 ? {
        showRefreshButton: eulaFetchError,
        onRefresh: function () {
            setEulaFetchError(false);
            void loadAndCacheEula();
        },
    } : _h;
    return (react_1.default.createElement(EulaScreenBase_1.EulaScreenBase, __assign({ WorkflowCardHeaderProps: workflowCardHeaderProps, eulaContent: eulaData, WorkflowCardBaseProps: __assign({ loading: isLoading }, WorkflowCardBaseProps), checkboxLabel: checkboxLabel, checkboxProps: checkboxProps, html: html, initialCheckboxValue: eulaAccepted, onEulaAcceptedChange: updateEulaAcceptedStatus, WorkflowCardActionsProps: workflowCardActionsProps, refreshConfig: refreshConfig }, otherEulaScreenProps, { errorDisplayConfig: errorDisplayConfig })));
};
exports.EulaScreen = EulaScreen;
