"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ForgotPasswordScreenBase = void 0;
var react_1 = __importStar(require("react"));
var TextField_1 = __importDefault(require("@mui/material/TextField"));
var components_1 = require("../../components");
var SuccessScreen_1 = require("../SuccessScreen");
var ErrorManager_1 = __importDefault(require("../../components/Error/ErrorManager"));
/**
 * Component renders a screen with forgot password for support with the application.
 *
 * @param {ForgotPasswordScreenProps} props - props of ForgotPasswordScreen base component
 *
 * @category Component
 */
var ForgotPasswordScreenBase = function (props) {
    var _a;
    var _b = (0, react_1.useState)((_a = props.initialEmailValue) !== null && _a !== void 0 ? _a : ''), emailInput = _b[0], setEmailInput = _b[1];
    var emailLabel = props.emailLabel, _c = props.initialEmailValue, initialEmailValue = _c === void 0 ? '' : _c, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    _d = props.emailValidator, 
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    emailValidator = _d === void 0 ? function (email) { return true; } : _d, slots = props.slots, _e = props.slotProps, slotProps = _e === void 0 ? {} : _e, showSuccessScreen = props.showSuccessScreen, errorDisplayConfig = props.errorDisplayConfig, emailTextFieldProps = props.emailTextFieldProps, _f = props.WorkflowCardBaseProps, cardBaseProps = _f === void 0 ? {} : _f, _g = props.WorkflowCardInstructionProps, instructionsProps = _g === void 0 ? {} : _g, _h = props.WorkflowCardActionsProps, actionsProps = _h === void 0 ? {} : _h, _j = props.WorkflowCardHeaderProps, headerProps = _j === void 0 ? {} : _j, otherProps = __rest(props, ["emailLabel", "initialEmailValue", "emailValidator", "slots", "slotProps", "showSuccessScreen", "errorDisplayConfig", "emailTextFieldProps", "WorkflowCardBaseProps", "WorkflowCardInstructionProps", "WorkflowCardActionsProps", "WorkflowCardHeaderProps"]);
    var validateEmail = function () { return typeof emailValidator(initialEmailValue) !== 'string'; };
    var _k = (0, react_1.useState)(validateEmail), isEmailValid = _k[0], setIsEmailValid = _k[1];
    var _l = (0, react_1.useState)(!validateEmail() ? emailValidator(initialEmailValue) : ''), emailError = _l[0], setEmailError = _l[1];
    var _m = (0, react_1.useState)(initialEmailValue !== '' || validateEmail), shouldValidateEmail = _m[0], setShouldValidateEmail = _m[1];
    var handleEmailInputChange = (0, react_1.useCallback)(function (email) {
        setEmailInput(email);
        var emailValidatorResponse = emailValidator(email);
        setIsEmailValid(typeof emailValidatorResponse === 'boolean' ? emailValidatorResponse : false);
        setEmailError(typeof emailValidatorResponse === 'string' ? emailValidatorResponse : '');
    }, [emailValidator]);
    var handleOnNext = function () {
        var onNext = actionsProps.onNext;
        if (onNext) {
            onNext({ email: emailInput });
        }
    };
    var getSuccessScreen = function (_props, SuccessScreen) { return (SuccessScreen ? SuccessScreen(_props) : react_1.default.createElement(SuccessScreen_1.SuccessScreenBase, __assign({}, _props))); };
    return (react_1.default.createElement(react_1.default.Fragment, null, showSuccessScreen ? (getSuccessScreen((slotProps === null || slotProps === void 0 ? void 0 : slotProps.SuccessScreen) || {}, slots === null || slots === void 0 ? void 0 : slots.SuccessScreen)) : (react_1.default.createElement(components_1.WorkflowCard, __assign({}, cardBaseProps, otherProps),
        react_1.default.createElement(components_1.WorkflowCardHeader, __assign({}, headerProps)),
        react_1.default.createElement(components_1.WorkflowCardInstructions, __assign({}, instructionsProps)),
        react_1.default.createElement(components_1.WorkflowCardBody, null,
            react_1.default.createElement(ErrorManager_1.default, __assign({}, errorDisplayConfig),
                react_1.default.createElement(TextField_1.default, __assign({ id: "email", label: emailLabel, fullWidth: true, value: emailInput, variant: "filled", error: shouldValidateEmail && !isEmailValid, helperText: shouldValidateEmail && emailError }, emailTextFieldProps, { onBlur: function (e) {
                        // eslint-disable-next-line no-unused-expressions
                        (emailTextFieldProps === null || emailTextFieldProps === void 0 ? void 0 : emailTextFieldProps.onBlur) && emailTextFieldProps.onBlur(e);
                        setShouldValidateEmail(true);
                    }, onChange: function (evt) {
                        // eslint-disable-next-line no-unused-expressions
                        (emailTextFieldProps === null || emailTextFieldProps === void 0 ? void 0 : emailTextFieldProps.onChange) && emailTextFieldProps.onChange(evt);
                        handleEmailInputChange(evt.target.value);
                    }, onKeyUp: function (e) {
                        if (e.key === 'Enter' &&
                            ((emailInput.length > 0 && isEmailValid) || actionsProps.canGoNext))
                            handleOnNext();
                    } })))),
        react_1.default.createElement(components_1.WorkflowCardActions, __assign({}, actionsProps, { canGoNext: emailInput.length > 0 && isEmailValid && actionsProps.canGoNext, onNext: handleOnNext }))))));
};
exports.ForgotPasswordScreenBase = ForgotPasswordScreenBase;
