"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OktaRedirectLoginScreen = void 0;
var react_1 = __importStar(require("react"));
var okta_react_1 = require("@okta/okta-react");
var react_i18next_1 = require("react-i18next");
var OktaRedirectLoginScreenBase_1 = require("./OktaRedirectLoginScreenBase");
var contexts_1 = require("../../contexts");
/**
 * Component that renders an okta login screen.
 *
 * @param {OktaRedirectLoginScreenProps} props - props of OktaRedirectLoginScreen
 *
 * @category Component
 */
var OktaRedirectLoginScreen = function (props) {
    var _a = (0, okta_react_1.useOktaAuth)(), authState = _a.authState, oktaAuth = _a.oktaAuth;
    var _b = (0, react_1.useState)(!authState), isLoading = _b[0], setIsLoading = _b[1];
    var t = (0, react_i18next_1.useTranslation)().t;
    var _c = (0, contexts_1.useOktaAuthContext)(), navigate = _c.navigate, routeConfig = _c.routeConfig;
    var _d = props.loginButtonLabel, loginButtonLabel = _d === void 0 ? t('bluiCommon:ACTIONS.OKTA_LOG_IN') : _d, _e = props.showForgotPassword, showForgotPassword = _e === void 0 ? true : _e, _f = props.forgotPasswordLabel, forgotPasswordLabel = _f === void 0 ? t('bluiCommon:LABELS.FORGOT_PASSWORD') : _f, _g = props.onForgotPassword, onForgotPassword = _g === void 0 ? function () { return navigate(routeConfig.FORGOT_PASSWORD); } : _g, _h = props.showSelfRegistration, showSelfRegistration = _h === void 0 ? true : _h, _j = props.selfRegisterInstructions, selfRegisterInstructions = _j === void 0 ? t('bluiCommon:LABELS.NEED_ACCOUNT') : _j, _k = props.selfRegisterButtonLabel, selfRegisterButtonLabel = _k === void 0 ? t('bluiCommon:ACTIONS.CREATE_ACCOUNT') : _k, _l = props.onSelfRegister, onSelfRegister = _l === void 0 ? function () { return navigate(routeConfig.REGISTER_SELF); } : _l, _m = props.showContactSupport, showContactSupport = _m === void 0 ? true : _m, _o = props.contactSupportLabel, contactSupportLabel = _o === void 0 ? t('bluiCommon:MESSAGES.CONTACT') : _o, _p = props.onContactSupport, onContactSupport = _p === void 0 ? function () { return navigate(routeConfig.SUPPORT); } : _p, _q = props.showCyberSecurityBadge, showCyberSecurityBadge = _q === void 0 ? true : _q, projectImage = props.projectImage, header = props.header, footer = props.footer, otherProps = __rest(props, ["loginButtonLabel", "showForgotPassword", "forgotPasswordLabel", "onForgotPassword", "showSelfRegistration", "selfRegisterInstructions", "selfRegisterButtonLabel", "onSelfRegister", "showContactSupport", "contactSupportLabel", "onContactSupport", "showCyberSecurityBadge", "projectImage", "header", "footer"]);
    (0, react_1.useEffect)(function () {
        setIsLoading(!authState);
    }, [authState]);
    var handleOnLogin = function () { return __awaiter(void 0, void 0, void 0, function () {
        var _error_1;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 3, 4, 5]);
                    setIsLoading(true);
                    return [4 /*yield*/, oktaAuth.signInWithRedirect()];
                case 1:
                    _b.sent();
                    return [4 /*yield*/, ((_a = props.onLogin) === null || _a === void 0 ? void 0 : _a.call(props))];
                case 2:
                    _b.sent();
                    return [3 /*break*/, 5];
                case 3:
                    _error_1 = _b.sent();
                    // eslint-disable-next-line no-console
                    console.log(_error_1);
                    return [3 /*break*/, 5];
                case 4:
                    setIsLoading(false);
                    return [7 /*endfinally*/];
                case 5: return [2 /*return*/];
            }
        });
    }); };
    return (react_1.default.createElement(OktaRedirectLoginScreenBase_1.OktaRedirectLoginScreenBase, __assign({ loading: isLoading, loginButtonLabel: loginButtonLabel, onLogin: handleOnLogin, showForgotPassword: showForgotPassword, forgotPasswordLabel: forgotPasswordLabel, onForgotPassword: onForgotPassword, showSelfRegistration: showSelfRegistration, selfRegisterButtonLabel: selfRegisterButtonLabel, selfRegisterInstructions: selfRegisterInstructions, onSelfRegister: onSelfRegister, showContactSupport: showContactSupport, contactSupportLabel: contactSupportLabel, onContactSupport: onContactSupport, showCyberSecurityBadge: showCyberSecurityBadge, projectImage: projectImage, header: header, footer: footer }, otherProps)));
};
exports.OktaRedirectLoginScreen = OktaRedirectLoginScreen;
