"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SuccessScreenBase = void 0;
var react_1 = __importDefault(require("react"));
var WorkflowCard_1 = require("../../components/WorkflowCard");
var react_components_1 = require("@brightlayer-ui/react-components");
var Box_1 = __importDefault(require("@mui/material/Box"));
/**
 * Component that renders a success screen
 *
 * @param {SuccessScreenProps} props - props of SuccessScreen base component
 *
 * @category Component
 */
var SuccessScreenBase = function (props) {
    var EmptyStateProps = props.EmptyStateProps, _a = props.dismissButtonLabel, dismissButtonLabel = _a === void 0 ? '' : _a, canDismiss = props.canDismiss, onDismiss = props.onDismiss, _b = props.WorkflowCardBaseProps, cardBaseProps = _b === void 0 ? {} : _b, _c = props.WorkflowCardInstructionProps, instructionsProps = _c === void 0 ? {} : _c, _d = props.WorkflowCardActionsProps, actionsProps = _d === void 0 ? {} : _d, _e = props.WorkflowCardHeaderProps, headerProps = _e === void 0 ? {} : _e, otherProps = __rest(props, ["EmptyStateProps", "dismissButtonLabel", "canDismiss", "onDismiss", "WorkflowCardBaseProps", "WorkflowCardInstructionProps", "WorkflowCardActionsProps", "WorkflowCardHeaderProps"]);
    return (react_1.default.createElement(WorkflowCard_1.WorkflowCard, __assign({}, cardBaseProps, otherProps),
        react_1.default.createElement(WorkflowCard_1.WorkflowCardHeader, __assign({}, headerProps)),
        Object.keys(instructionsProps).length !== 0 && react_1.default.createElement(WorkflowCard_1.WorkflowCardInstructions, __assign({}, instructionsProps)),
        react_1.default.createElement(WorkflowCard_1.WorkflowCardBody, null,
            react_1.default.createElement(Box_1.default, { sx: [
                    {
                        display: 'flex',
                        flex: '1 1 0%',
                        justifyContent: 'center',
                        alignItems: 'center',
                        height: '100%',
                        minHeight: { md: 500, sm: 'auto' },
                    },
                ] }, EmptyStateProps && (react_1.default.createElement(react_components_1.EmptyState, __assign({ sx: {
                    color: 'inherit',
                    p: 0,
                } }, EmptyStateProps))))),
        react_1.default.createElement(WorkflowCard_1.WorkflowCardActions, __assign({}, actionsProps, { nextLabel: dismissButtonLabel || actionsProps.nextLabel, canGoNext: canDismiss, onNext: function () {
                if (onDismiss)
                    onDismiss();
                if (actionsProps.onNext)
                    actionsProps.onNext();
            } }))));
};
exports.SuccessScreenBase = SuccessScreenBase;
