"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VerifyCodeScreen = void 0;
var react_1 = __importStar(require("react"));
var VerifyCodeScreenBase_1 = require("./VerifyCodeScreenBase");
var contexts_1 = require("../../contexts");
var useErrorManager_1 = require("../../contexts/ErrorContext/useErrorManager");
var react_i18next_1 = require("react-i18next");
/**
 * Component that renders a screen that prompts a user to enter the confirmation code
 * that was sent to the email address that they used to register.
 *
 * @param {VerifyCodeScreenProps} props - props of VerifyCodeScreen
 *
 * @category Component
 */
var VerifyCodeScreen = function (props) {
    var t = (0, react_i18next_1.useTranslation)().t;
    var regWorkflow = (0, contexts_1.useRegistrationWorkflowContext)();
    var actions = (0, contexts_1.useRegistrationContext)().actions;
    var nextScreen = regWorkflow.nextScreen, previousScreen = regWorkflow.previousScreen, screenData = regWorkflow.screenData, currentScreen = regWorkflow.currentScreen, totalScreens = regWorkflow.totalScreens, updateScreenData = regWorkflow.updateScreenData;
    var emailAddress = screenData.CreateAccount.emailAddress;
    var _a = (0, useErrorManager_1.useErrorManager)(), triggerError = _a.triggerError, errorManagerConfig = _a.errorManagerConfig;
    var errorDisplayConfig = __assign(__assign(__assign({}, errorManagerConfig), props.errorDisplayConfig), { onClose: function () {
            if (props.errorDisplayConfig && props.errorDisplayConfig.onClose)
                props.errorDisplayConfig.onClose();
            if (errorManagerConfig.onClose)
                errorManagerConfig === null || errorManagerConfig === void 0 ? void 0 : errorManagerConfig.onClose();
        } });
    var _b = (0, react_1.useState)(screenData.VerifyCode.code), verifyCode = _b[0], setVerifyCode = _b[1];
    var _c = (0, react_1.useState)(false), isLoading = _c[0], setIsLoading = _c[1];
    var requestResendCode = (0, react_1.useCallback)(function () { return __awaiter(void 0, void 0, void 0, function () {
        var _error_1;
        var _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 2, 3, 4]);
                    setIsLoading(true);
                    return [4 /*yield*/, ((_a = actions === null || actions === void 0 ? void 0 : actions.requestRegistrationCode) === null || _a === void 0 ? void 0 : _a.call(actions, emailAddress ? emailAddress : ''))];
                case 1:
                    _b.sent();
                    return [3 /*break*/, 4];
                case 2:
                    _error_1 = _b.sent();
                    triggerError(_error_1);
                    return [3 /*break*/, 4];
                case 3:
                    setIsLoading(false);
                    return [7 /*endfinally*/];
                case 4: return [2 /*return*/];
            }
        });
    }); }, [actions, emailAddress, triggerError]);
    var _d = props.codeValidator, codeValidator = _d === void 0 ? function (code) {
        return (code === null || code === void 0 ? void 0 : code.length) > 0 ? true : t('bluiRegistration:SELF_REGISTRATION.VERIFY_EMAIL.CODE_VALIDATOR_ERROR');
    } : _d, _e = props.onResend, onResend = _e === void 0 ? function () {
        void requestResendCode();
    } : _e, _f = props.resendInstructions, resendInstructions = _f === void 0 ? t('bluiRegistration:SELF_REGISTRATION.VERIFY_EMAIL.VERIFICATION_CODE_PROMPT') : _f, _g = props.resendLabel, resendLabel = _g === void 0 ? t('bluiCommon:ACTIONS.RESEND') : _g, _h = props.verifyCodeInputLabel, verifyCodeInputLabel = _h === void 0 ? t('bluiRegistration:SELF_REGISTRATION.VERIFY_EMAIL.VERIFICATION') : _h, _j = props.initialValue, initialValue = _j === void 0 ? screenData.VerifyCode.code : _j, verifyCodeTextFieldProps = props.verifyCodeTextFieldProps, otherProps = __rest(props, ["codeValidator", "onResend", "resendInstructions", "resendLabel", "verifyCodeInputLabel", "initialValue", "verifyCodeTextFieldProps"]);
    var handleOnNext = (0, react_1.useCallback)(function (code, email) { return __awaiter(void 0, void 0, void 0, function () {
        var _a, codeValid, accountExists, _error_2;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 3, 4, 5]);
                    setIsLoading(true);
                    if (!(actions === null || actions === void 0 ? void 0 : actions.validateUserRegistrationRequest)) return [3 /*break*/, 2];
                    return [4 /*yield*/, (actions === null || actions === void 0 ? void 0 : actions.validateUserRegistrationRequest(code, email))];
                case 1:
                    _a = _b.sent(), codeValid = _a.codeValid, accountExists = _a.accountExists;
                    if (accountExists) {
                        updateScreenData({ screenId: 'VerifyCode', values: { code: code }, isAccountExist: accountExists });
                    }
                    else {
                        if (typeof codeValid === 'boolean') {
                            if (codeValid)
                                void nextScreen({
                                    screenId: 'VerifyCode',
                                    values: { code: code },
                                    isAccountExist: accountExists,
                                });
                            else {
                                triggerError(new Error(t('bluiRegistration:SELF_REGISTRATION.VERIFY_EMAIL.CODE_VALIDATOR_ERROR')));
                            }
                        }
                        else {
                            triggerError(new Error(codeValid));
                        }
                    }
                    _b.label = 2;
                case 2: return [3 /*break*/, 5];
                case 3:
                    _error_2 = _b.sent();
                    triggerError(_error_2);
                    return [3 /*break*/, 5];
                case 4:
                    setIsLoading(false);
                    return [7 /*endfinally*/];
                case 5: return [2 /*return*/];
            }
        });
    }); }, [t, actions, nextScreen, triggerError, updateScreenData]);
    var onPrevious = function (code) {
        previousScreen({
            screenId: 'VerifyCode',
            values: { code: code },
        });
    };
    var WorkflowCardBaseProps = props.WorkflowCardBaseProps, WorkflowCardHeaderProps = props.WorkflowCardHeaderProps, WorkflowCardInstructionProps = props.WorkflowCardInstructionProps, WorkflowCardActionsProps = props.WorkflowCardActionsProps;
    var workflowCardBaseProps = __assign({ loading: isLoading }, WorkflowCardBaseProps);
    var workflowCardHeaderProps = __assign({ title: t('bluiRegistration:REGISTRATION.STEPS.VERIFY_EMAIL') }, WorkflowCardHeaderProps);
    var workflowCardInstructionProps = __assign({ instructions: t('bluiRegistration:SELF_REGISTRATION.VERIFY_EMAIL.MESSAGE') }, WorkflowCardInstructionProps);
    var workflowCardActionsProps = __assign(__assign({ showNext: true, nextLabel: t('bluiCommon:ACTIONS.NEXT'), showPrevious: true, previousLabel: t('bluiCommon:ACTIONS.BACK'), canGoPrevious: true, currentStep: currentScreen, totalSteps: totalScreens }, WorkflowCardActionsProps), { onNext: function (data) {
            var _a;
            setVerifyCode(data.code);
            void handleOnNext(data.code, emailAddress);
            (_a = WorkflowCardActionsProps === null || WorkflowCardActionsProps === void 0 ? void 0 : WorkflowCardActionsProps.onNext) === null || _a === void 0 ? void 0 : _a.call(WorkflowCardActionsProps);
        }, onPrevious: function (data) {
            var _a;
            void onPrevious(data.code);
            (_a = WorkflowCardActionsProps === null || WorkflowCardActionsProps === void 0 ? void 0 : WorkflowCardActionsProps.onPrevious) === null || _a === void 0 ? void 0 : _a.call(WorkflowCardActionsProps);
        } });
    return (react_1.default.createElement(VerifyCodeScreenBase_1.VerifyCodeScreenBase, __assign({ WorkflowCardBaseProps: workflowCardBaseProps, WorkflowCardHeaderProps: workflowCardHeaderProps, WorkflowCardInstructionProps: workflowCardInstructionProps, WorkflowCardActionsProps: workflowCardActionsProps, resendInstructions: resendInstructions, resendLabel: resendLabel, verifyCodeInputLabel: verifyCodeInputLabel, initialValue: verifyCode.length > 0 ? verifyCode : initialValue, onResend: onResend, codeValidator: codeValidator, verifyCodeTextFieldProps: verifyCodeTextFieldProps }, otherProps, { errorDisplayConfig: errorDisplayConfig })));
};
exports.VerifyCodeScreen = VerifyCodeScreen;
